# std::bitset< _Nb > Class Template Reference
[Containers]

The %bitset class represents a fixed-size sequence of bits. More...

List of all members.

## Public Methods

| bitset ()
| All bits set to zero.
| bitset (unsigned long __val)
| Initial bits bitwise-copied from a single word (others set to zero).
template<class _CharT, class _Traits, class _Alloc> | bitset (const basic_string< _CharT, _Traits, _Alloc > &__s, size_t __pos=0)
| Use a subset of a string.
template<class _CharT, class _Traits, class _Alloc> | bitset (const basic_string< _CharT, _Traits, _Alloc > &__s, size_t __pos, size_t __n)
| Use a subset of a string.
bitset< _Nb > & | set ()
| Sets every bit to true.
bitset< _Nb > & | set (size_t __pos, bool __val=true)
| Sets a given bit to a particular value.
bitset< _Nb > & | reset ()
| Sets every bit to false.
bitset< _Nb > & | reset (size_t __pos)
| Sets a given bit to false.
bitset< _Nb > & | flip ()
| Toggles every bit to its opposite value.
bitset< _Nb > & | flip (size_t __pos)
| Toggles a given bit to its opposite value.
bitset< _Nb > | operator~ () const
| See the no-argument flip().
unsigned long | to_ulong () const
| Retuns a numerical interpretation of the %bitset.
template<class _CharT, class _Traits, class _Alloc> basic_string< _CharT, _Traits, _Alloc > | to_string () const
| Retuns a character interpretation of the %bitset.
size_t | count () const
| Returns the number of bits which are set.
size_t | size () const
| Returns the total number of bits.
bool | test (size_t __pos) const
| Tests the value of a bit.
bool | any () const
| Tests whether any of the bits are on.
bool | none () const
| Tests whether any of the bits are on.
size_t | _Find_first () const
| Finds the index of the first "on" bit.
size_t | _Find_next (size_t __prev) const
| Finds the index of the next "on" bit after prev.
bitset< _Nb > & | operator &= (const bitset< _Nb > &__rhs)
| Operations on bitsets.
bitset< _Nb > & | operator|= (const bitset< _Nb > &__rhs)
| Operations on bitsets.
bitset< _Nb > & | operator^= (const bitset< _Nb > &__rhs)
| Operations on bitsets.
bitset< _Nb > & | operator<<= (size_t __pos)
| Operations on bitsets.
bitset< _Nb > & | operator>>= (size_t __pos)
| Operations on bitsets.
bitset< _Nb > & | _Unchecked_set (size_t __pos)
bitset< _Nb > & | _Unchecked_set (size_t __pos, int __val)
bitset< _Nb > & | _Unchecked_reset (size_t __pos)
bitset< _Nb > & | _Unchecked_flip (size_t __pos)
bool | _Unchecked_test (size_t __pos) const
reference | operator[] (size_t __pos)
| Array-indexing support.
bool | operator[] (size_t __pos) const
| Array-indexing support.
bool | operator== (const bitset< _Nb > &__rhs) const
| These comparisons for equality/inequality are, well, bitwise.
bool | operator!= (const bitset< _Nb > &__rhs) const
| These comparisons for equality/inequality are, well, bitwise.
bitset< _Nb > | operator<< (size_t __pos) const
| Self-explanatory.
bitset< _Nb > | operator>> (size_t __pos) const
| Self-explanatory.

## Detailed Description

### template<size_t _Nb>
class std::bitset< _Nb >

The %bitset class represents a fixed-size sequence of bits.

(Note that %bitset does not meet the formal requirements of a container. Mainly, it lacks iterators.)

The template argument, _Nb, may be any non-negative number of type size_t.

A %bitset of size N uses U bits, where U = (N % (sizeof(unsigned long) * CHAR_BIT)). Thus, N - U bits are unused. (They are the high-order bits in the highest word.) It is a class invariant that those unused bits are always zero.

If you think of %bitset as "a simple array of bits," be aware that your mental picture is reversed: a %bitset behaves the same way as bits in integers do, with the bit at index 0 in the "least significant / right-hand" position, and the bit at index N-1 in the "most significant / left-hand" position. Thus, unlike other containers, a %bitset's index "counts from right to left," to put it very loosely.

This behavior is preserved when translating to and from strings. For example, the first line of the following program probably prints "b('a') is 0001100001" on a modern ASCII system.

         #include <bitset>
         #include <iostream>
         #include <sstream>

         using namespace std;

         int main()
         {
             long         a = 'a';
             bitset<10>   b(a);

             cout << "b('a') is " << b << endl;

             ostringstream s;
             s << b;
             string  str = s.str();
             cout << "index 3 in the string is " << str[3] << " but\n"
                  << "index 3 in the bitset is " << b[3] << endl;
         }

Also see http://gcc.gnu.org/onlinedocs/libstdc++/ext/sgiexts.html#ch23

Definition at line 637 of file bitset.

## Constructor & Destructor Documentation

template<size_t _Nb>
std::bitset< _Nb >::bitset | ( |  | ) | `[inline]`

| All bits set to zero. Definition at line 725 of file bitset.

template<size_t _Nb>
std::bitset< _Nb >::bitset | ( | unsigned long | __val | ) | `[inline]`

| Initial bits bitwise-copied from a single word (others set to zero). Definition at line 728 of file bitset.

template<size_t _Nb>
template<class _CharT, class _Traits, class _Alloc>
std::bitset< _Nb >::bitset | ( | const basic_string< _CharT, _Traits, _Alloc > & | __s,
|  | size_t | __pos = 0
| ) | `[inline, explicit]`

Use a subset of a string.

Parameters:

  s | A string of '0' and '1' characters.
  pos | Index of the first character in s to use; defaults to zero.

Exceptions:

  std::out_of_range | If pos is bigger the size of s.
  std::invalid_argument | If a character appears in the string which is neither '0' nor '1'.

Definition at line 741 of file bitset.

References std::basic_string< _CharT, _Traits, _Alloc >::size() .

template<size_t _Nb>
template<class _CharT, class _Traits, class _Alloc>
std::bitset< _Nb >::bitset | ( | const basic_string< _CharT, _Traits, _Alloc > & | __s,
|  | size_t | __pos,
|  | size_t | __n
| ) | `[inline]`

Use a subset of a string.

Parameters:

  s | A string of '0' and '1' characters.
  pos | Index of the first character in s to use.
  n | The number of characters to copy.

Exceptions:

  std::out_of_range | If pos is bigger the size of s.
  std::invalid_argument | If a character appears in the string which is neither '0' nor '1'.

Definition at line 761 of file bitset.

References std::basic_string< _CharT, _Traits, _Alloc >::size() .

## Member Function Documentation

template<size_t _Nb>
bool std::bitset< _Nb >::any | ( |  | ) | const`[inline]`

Tests whether any of the bits are on.

Returns:
  True if at least one bit is set.

Definition at line 1052 of file bitset.

template<size_t _Nb>
size_t std::bitset< _Nb >::count | ( |  | ) | const`[inline]`

| Returns the number of bits which are set. Definition at line 1016 of file bitset.

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::flip | ( | size_t | __pos | ) | `[inline]`

Toggles a given bit to its opposite value.

Parameters:

  pos | The index of the bit.

Exceptions:

  std::out_of_range | If pos is bigger the size of the %set.

Definition at line 937 of file bitset.

References std::bitset< _Nb >::_Unchecked_flip() .

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::flip | ( |  | ) | `[inline]`

| Toggles every bit to its opposite value. Definition at line 924 of file bitset.

template<size_t _Nb>
bool std::bitset< _Nb >::none | ( |  | ) | const`[inline]`

Tests whether any of the bits are on.

Returns:
  True if none of the bits are set.

Definition at line 1059 of file bitset.

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::operator &= | ( | const bitset< _Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 779 of file bitset.

template<size_t _Nb>
bool std::bitset< _Nb >::operator!= | ( | const bitset< _Nb > & | __rhs | ) | const`[inline]`

| These comparisons for equality/inequality are, well, bitwise. Definition at line 1029 of file bitset.

template<size_t _Nb>
bitset<_Nb> std::bitset< _Nb >::operator<< | ( | size_t | __pos | ) | const`[inline]`

| Self-explanatory. Definition at line 1064 of file bitset.

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::operator<<= | ( | size_t | __pos | ) | `[inline]`

Operations on bitsets.

Parameters:

  pos | The number of places to shift.

These should be self-explanatory.

Definition at line 808 of file bitset.

template<size_t _Nb>
bool std::bitset< _Nb >::operator== | ( | const bitset< _Nb > & | __rhs | ) | const`[inline]`

| These comparisons for equality/inequality are, well, bitwise. Definition at line 1025 of file bitset.

template<size_t _Nb>
bitset<_Nb> std::bitset< _Nb >::operator>> | ( | size_t | __pos | ) | const`[inline]`

| Self-explanatory. Definition at line 1068 of file bitset.

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::operator>>= | ( | size_t | __pos | ) | `[inline]`

Operations on bitsets.

Parameters:

  pos | The number of places to shift.

These should be self-explanatory.

Definition at line 816 of file bitset.

template<size_t _Nb>
bool std::bitset< _Nb >::operator[] | ( | size_t | __pos | ) | const`[inline]`

Array-indexing support.

Parameters:

  pos | Index into the %bitset.

Returns:
  A bool for a 'const %bitset'. For non-const bitsets, an instance of the reference proxy class.

Note:
  These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

Definition at line 969 of file bitset.

References std::bitset< _Nb >::_Unchecked_test() .

template<size_t _Nb>
reference std::bitset< _Nb >::operator[] | ( | size_t | __pos | ) | `[inline]`

Array-indexing support.

Parameters:

  pos | Index into the %bitset.

Returns:
  A bool for a 'const %bitset'. For non-const bitsets, an instance of the reference proxy class.

Note:
  These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

Definition at line 966 of file bitset.

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::operator^= | ( | const bitset< _Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 793 of file bitset.

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::operator|= | ( | const bitset< _Nb > & | __rhs | ) | `[inline]`

Operations on bitsets.

Parameters:

  rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 786 of file bitset.

template<size_t _Nb>
bitset<_Nb> std::bitset< _Nb >::operator~ | ( |  | ) | const`[inline]`

| See the no-argument flip(). Definition at line 946 of file bitset.

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::reset | ( | size_t | __pos | ) | `[inline]`

Sets a given bit to false.

Parameters:

  pos | The index of the bit.

Exceptions:

  std::out_of_range | If pos is bigger the size of the %set.

Same as writing `set(pos,false).`

Definition at line 913 of file bitset.

References std::bitset< _Nb >::_Unchecked_reset() .

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::reset | ( |  | ) | `[inline]`

| Sets every bit to false. Definition at line 899 of file bitset.

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::set | ( | size_t | __pos,
|  | bool | __val = true
| ) | `[inline]`

Sets a given bit to a particular value.

Parameters:

  pos | The index of the bit.
  val | Either true or false, defaults to true.

Exceptions:

  std::out_of_range | If pos is bigger the size of the %set.

Definition at line 888 of file bitset.

References std::bitset< _Nb >::_Unchecked_set() .

template<size_t _Nb>
bitset<_Nb>& std::bitset< _Nb >::set | ( |  | ) | `[inline]`

| Sets every bit to true. Definition at line 874 of file bitset.

template<size_t _Nb>
size_t std::bitset< _Nb >::size | ( |  | ) | const`[inline]`

| Returns the total number of bits. Definition at line 1020 of file bitset.

template<size_t _Nb>
bool std::bitset< _Nb >::test | ( | size_t | __pos | ) | const`[inline]`

Tests the value of a bit.

Parameters:

  pos | The index of a bit.

Returns:
  The value at pos.

Exceptions:

  std::out_of_range | If pos is bigger the size of the %set.

Definition at line 1040 of file bitset.

References std::bitset< _Nb >::_Unchecked_test() .

template<size_t _Nb>
template<class _CharT, class _Traits, class _Alloc>
basic_string<_CharT, _Traits, _Alloc> std::bitset< _Nb >::to_string | ( |  | ) | const`[inline]`

Retuns a character interpretation of the %bitset.

Returns:
  The string equivalent of the bits.

Note the ordering of the bits: decreasing character positions correspond to increasing bit positions (see the main class notes for an example).

Also note that you must specify the string's template parameters explicitly. Given a bitset `bs` and a string :

         s = bs.to_string<char,char_traits<char>,allocator<char> >();

Definition at line 997 of file bitset.

template<size_t _Nb>
unsigned long std::bitset< _Nb >::to_ulong | ( |  | ) | const`[inline]`

Retuns a numerical interpretation of the %bitset.

Returns:
  The integral equivalent of the bits.

Exceptions:

  std::overflow_error | If there are too many bits to be represented in an `unsigned` `long.`

Definition at line 979 of file bitset.

The documentation for this class was generated from the following file:

- bitset